<?php

    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;
    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;

	require_once("lib/fconnect.php");
	$db = DBConnect::getInstance();

    require_once("lib/frole.php");
    $role = new Role();
	$role->isPageEnable($user->uuid);

	require_once("lib/fhighcharts.php");
	$chatrs = new HighCharts();

	function actualDate(){
		$day = (int)date("d");
		$month = (int)date("m");
		$year = (int)date("Y");
		if($day<=26){
			$month--;
			if($month==0){
					$year--;
					$month = 12;
			}

		}
		return '26.'.$month.'.'.$year;
	}

	function divide_on_the_rates($chislo,$rates,$round = 3){
		return round($chislo/$rates,$round);
	}

	function castingWithMedian($array, $counter, $value){
		arsort($array);
		$array = array_diff($array, array(0));
		if(count($array) < $counter){
			$array[] = 0;
		}
		$count = count($array);
		$keys = array_keys($array);
		$values = array_values($array);
		$min = $values[$count-1];
		$max = $values[0];
		if(is_int($count/2)){
			$key1 = $count/2;
			$key2 = $count/2-1;
			$median = ($values[$key1]+$values[$key2])/2;
		}else{
			$key1 = floor($count/2);
			$median = $values[$key1];
		}
	if($value < $min || $value > $max){
		die('Ошибка приведения: неправильные параметры функции приведения');
	}
	if($value === $min){return 0;}
	if($value === $max){return 100;}
	if($value === $median){ return 50;}
	if($value > $min && $value < $median){
		return 50*($value-$min)/($median-$min);
	}
	if($value > $median && $value < $max){
		return 50+50*($value-$median)/($max-$median);
	}
	die('Неизвестная ошибка приведения');
}

$topCount = 5;

$i = 0;
$out['head'] = '';
$out['body'] = '';
	$params = $db->colModel->findOne( array('name'=>'chair'));

	if (!isset($_GET['chairtype'])) {
		$_GET['chairtype'] = "";
	}
	if(isset($_GET['chairtype'])){
		switch($_GET['chairtype']){
			case 'E':
				$what = array('type'=>'chair','chairtype'=>'E');
				$plotcolor = '#699954';
				$heading = "Топ $topCount кафедр естественнонаучного профиля";
			break;
			case 'G':
				$what = array('type'=>'chair','chairtype'=>'G');
				$plotcolor = '#A75C69';
				$heading = "Топ $topCount кафедр гуманитарного профиля";
			break;
			case 'T':
				$what = array('type'=>'chair','chairtype'=>'T');
				$plotcolor = '#B29162';
				$heading = "Топ $topCount кафедр творческого профиля";
			break;
			case 'P':
				$what = array('type'=>'chair','chairtype'=>'P');
				$plotcolor = '#90708C';
				$heading = "Топ $topCount кафедр педагогического профиля";
			break;
			default:
				$what = array('type'=>'chair');
				$plotcolor = '#435C73';
				$heading = "Топ $topCount кафедр университета";
		}
	}
	$chairs = $db->colDocs->find($what);
	$chairsCounter =  $db->colDocs->count($what);


	$now = actualDate();
	$itemlist = '<table>';
foreach($params['items'] as $item){

	if(isset($item['pdf']) && $item['pdf']){
		$j = 0;
		if(isset($item['type'])){
			if($item['type'] == 'section'){
				$out['body'] .= '<div><h3 style="text-align:center;margin-top:45px;" id="' . $item['name'] . '">Раздел '.++$i.': <b>'.$item['label_ru'].'</b></h3></div>';
			}elseif($item['type'] == 'subsection'){
				$subtext = $item['label_ru'];
			}else{
				//$itemlist .= '<tr><td style="background-color:#bbbbbb;">'.$item['index_code_ru'].' '.$subtext.' '.$item['label_ru'].'</td></tr>';
				$title = addcslashes($item['index_code_ru'].' '.$subtext.' '.$item['label_ru'], "'");
				$title = addcslashes($title, '"');
				if($item['accumulative']){
					foreach($chairs as $chair){
						if(isset($chair[$item['name']])){
							$values[$chair['title_ru']] = $chair[$item['name']];
							if(!isset($chair['rates'])){
								$chair['rates']=1;
								 var_dump('Не указаны ставки - '.$chair['title_ru']);
								 }// плохо
							$values[$chair['title_ru']] = divide_on_the_rates($values[$chair['title_ru']],$chair['rates']);
						}
					}
				}else{
					foreach($chairs as $chair){
						$counter = 0;
						if(isset($chair[$item['name']])){
							$values[$chair['title_ru']] = $chair[$item['name']];
							if(isset($chair['versions'])){
								$counter++;
								if($counter < 9) continue;
								foreach($chair['versions'] as $version){
									
									if(isset($version['content']) && isset($version['content'][$item['name']])){
										$values[$chair['title_ru']] += $version['content'][$item['name']];
									}
								}
							}
							if(!isset($chair['rates'])){
								$chair['rates']=1;
								var_dump('Не указаны ставки - '.$chair['title_ru']);
								} //плохо
						$values[$chair['title_ru']] = divide_on_the_rates($values[$chair['title_ru']],$chair['rates']);
						}else{
							$values[$chair['title_ru']] = 0;
						}
					}
				}
				arsort($values);
				$full_arr = $values;
				array_splice($values, $topCount);
				foreach($values as $key => $value){
					if($value == 0 || !is_float($value)){
						unset($values[$key]);
					}else{
						$values[$key] = round(castingWithMedian($full_arr, $chairsCounter, $value),2);
					}
				}
				if(count($values)>0){
					$plot = $chatrs->getBar($values,$title,'данные актуальны на '.$now.'г.',md5($title),$plotcolor, '400px');
					$out['head'] .= $plot['head'];
					$out['body'] .= $plot['body'];
				}else{
						$out['body'] .= '<div style="height:100%;min-width: 600px; max-width: 1200px; width:100%; margin: 0 auto; background-color:#ffffff">

						<p style="color: #333333;text-align:center; font-size: 18px;font-weight:bold;">'.$title.' </p>
						<p></p>
						<p style="color:red; text-align:center;"><b>Нет данных для оценки !!!</b></p></div>';
				}
				unset($values,$full_arr);

			}

		}
	}
}

?>
<!doctype html>
<html lang="ru">
<head>
<meta charset="utf-8" />
<title>Бюллетень</title>
<link rel="stylesheet" href="/css/jquery-ui.css" />

<script src="/js/jquery-1.9.1.js"></script>
<script src="/js/jquery-ui.js"></script>
<script src="/js/jquery.form.js"></script>
<script src="/js/bootstrap.min.js"></script>
<script src="/js/highcharts/highcharts.js"></script>
<script src="/js/highcharts/highcharts-more.js"></script>
<script src="/js/highcharts/modules/exporting.js"></script>

<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
<script src="/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.form.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/admin.css" />
<link rel="stylesheet" href="/css/navigation__horizontal.css" />

<link rel="stylesheet" href="/css/colors.css">
<link rel="stylesheet" href="/css/buttons.css">
<link rel="stylesheet" href="/css/positions.css">

  <script src="/js/auth.js"></script>
  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";

  </script>
  <?php
  echo $out['head'];
  ?>
</head>

<body data-spy="scroll" data-target="#chapters">


<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings">
    <h1 class="header__headings__heading">
      Комплексный мониторинг кафедр
    </h1>
    <h2 class="header__headings__subheading">
      <small class="header__headings__subheading__subsubheading">
        Бюллетень
      </small>
    </h2>
  </div>

  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>

  <div class="header__helper"></div>
</header>

<div>
	<?php
echo $role->userMenu($user->uuid);
	?>
</div>


<!-- CURRENT PAGE -->



<div class="all">
	<div class="center">
		<div class="navbar">
			<a href="/bulletin.php" class="bt blue">Кафедры университета</button></a>
			<a href="/bulletin.php?chairtype=E" class="bt green">Естественнонаучный профиль</a>
			<a href="/bulletin.php?chairtype=G" class="bt red">Гуманитарный профиль</a>
			<a href="/bulletin.php?chairtype=T" class="bt brown">Творческий профиль</a>
			<a href="/bulletin.php?chairtype=P" class="bt violet">Педагогический профиль</a>
		</div>

		<h2 style="margin-top: 50px;"><?=$heading?></h2>

		<!--
		<div class="navbar" id="chapters">
			<ul class="nav">
				<li><a href="#chair_potential">1. Кадровый потенциал кафедры</a></li>
				<li><a href="#training_methodological_support">2. Учебно-методическое и дидактическое обеспечение образовательного процесса</a></li>
				<li><a href="#publishing_activity">3. Публикационная активность</a></li>
				<li><a href="#effectiveness_of_training_and_certification">4. Эффективность подготовки и аттестации кадров высшей квалификации</a></li>
				<li><a href="#yngxbniber">5. Эффективность реализации образовательной деятельности</a></li>
				<li><a href="#research">6. Выполнение фундаментальных и прикладных исследований</a></li>
				<li><a href="#social_activity">7. Воспитательная деятельность</a></li>
			</ul>
		</div>
		-->
	</div>

<?php
	echo $out['body'];
?>

</div>
</body>
</html>
